import { Middleware } from "../server";
import * as cache from "../../cache";
import { HashMap } from "../../common";
export interface MINEConfig {
    "MINE": string;
    "cachable"?: boolean;
    "maxCacheSize"?: number;
}
export declare let staticMineTypes: HashMap<MINEConfig>;
export interface StaticDelegateOptions {
    /**
     * The prefix of url.
     * NOTICE: Must be ending with "/".
     */
    prefix: string;
    /**
     * The root path of static resources.
     * NOTICE: Must be ending with "/".
     */
    root: string;
    /**
     * How long will the static files expire in client. (Seconds)
     */
    expires?: number;
    /**
     * How many bytes of buffer for output.
     */
    bufferSize?: number;
    /**
     * If this option is set, the static files will be cached in
     * memory with the built-in Memory cache engine.
     */
    memoryStorage?: {
        /**
         * Specify an ID for MemoryStorage table.
         */
        table: cache.IMemoryTable<any>;
        /**
         * How many bytes of data could be saved in memory cache.
         */
        maxSize?: number;
        /**
         * How long will the cache items expire, in seconds.
         */
        expires?: number;
        /**
         * How often does the Garbage Collector execute.
         */
        gcInterval?: number;
    };
}
export declare function StaticDelegate(options: StaticDelegateOptions): Middleware;
