"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var NodeFS = require("fs");
var logger_1 = require("./logger");
var FileLogger = (function (_super) {
    __extends(FileLogger, _super);
    function FileLogger(fd) {
        _super.call(this);
        this.filePointer = fd;
        this.registerType("default", FileLogger.generateBuiltInWriter("Normal"));
        this.registerType("warning", FileLogger.generateBuiltInWriter("Warning"));
        this.registerType("info", FileLogger.generateBuiltInWriter("Info"));
        this.registerType("error", FileLogger.generateBuiltInWriter("Error"));
    }
    FileLogger.create = function (fileName, callback) {
        NodeFS.exists(fileName, function (exists) {
            NodeFS.open(fileName, exists ? "a+" : "w", function (err, fd) {
                if (err) {
                    callback(err);
                }
                else {
                    var lgr = new FileLogger(fd);
                    callback(null, lgr);
                }
            });
        });
    };
    FileLogger.generateBuiltInWriter = function (level) {
        return function (text, next) {
            NodeFS.write(this.filePointer, this.timeGenerator() + (" - " + level + " - " + text + "\n"), next);
        };
    };
    return FileLogger;
}(logger_1.Logger));
exports.FileLogger = FileLogger;
//# sourceMappingURL=FileLogger.js.map