import { StdAsyncCallback, HashMap } from "../common";
export interface LoggerWriter {
    (this: Logger, data: string, next: StdAsyncCallback): void;
}
export interface LoggerTimeGenerator {
    (): string;
}
export declare abstract class Logger {
    protected writers: HashMap<LoggerWriter>;
    protected timeGenerator: LoggerTimeGenerator;
    constructor();
    /**
     * Set the formatter of time.
     */
    timeFormatter: LoggerTimeGenerator;
    /**
     * Register a new type of logging method.
     *
     * If a one existed, the old one will be overwritten.
     */
    registerType(type: string, writer: LoggerWriter): Logger;
    /**
     * Write a piece of log, and get the result in async way, if necessary.
     */
    write(data: any, type?: string, next?: StdAsyncCallback): Logger;
}
