"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var lrts_1 = require("../lrts");
/**
 * A class based on the synchronous EventEmitter.
 */
var SyncEventTester = (function (_super) {
    __extends(SyncEventTester, _super);
    function SyncEventTester() {
        _super.call(this);
    }
    SyncEventTester.prototype.test1 = function () {
        console.log("sync test1");
    };
    SyncEventTester.prototype.test2 = function () {
        console.log("sync test2");
    };
    SyncEventTester.prototype.test3 = function () {
        console.log("sync test3");
    };
    return SyncEventTester;
}(lrts_1.events.SyncEventEmitter));
/**
 * A class based on the asynchronous EventEmitter.
 */
var AsyncEventTester = (function (_super) {
    __extends(AsyncEventTester, _super);
    function AsyncEventTester() {
        _super.call(this);
    }
    AsyncEventTester.prototype.test1 = function () {
        console.log("async test1");
    };
    AsyncEventTester.prototype.test2 = function () {
        console.log("async test2");
    };
    AsyncEventTester.prototype.test3 = function () {
        console.log("async test3");
    };
    return AsyncEventTester;
}(lrts_1.events.AsyncEventEmitter));
/**
 * Test the synchronous class.
 */
var SEE = new SyncEventTester();
SEE.listen("test", function (a) {
    console.log(a);
    this.test1();
});
SEE.listenOnce("test", function (a) {
    console.log(a);
    this.test2();
});
SEE.listenOnce("test", function (a) {
    console.log("break", a);
    this.test3();
    return false; // break event transferring chain.
});
SEE.listen("test", function (a) {
    console.log(a);
    this.test3();
});
/**
 * Test the asynchronous class.
 */
var AEE = new AsyncEventTester();
AEE.on("hello", function (a, next) {
    console.log(a);
    this.test1();
    next(a === 3 ? new lrts_1.Exception("Hello-Exception", "This is a test for event error.") : null);
});
AEE.on("hello", function (a, next) {
    console.log(a);
    this.test2();
    next(null, a === 2); // break the transferring chain.
});
AEE.once("hello", function (a, next) {
    console.log("once", a);
    this.test3();
    next();
});
AEE.on("hello", function (a, next) {
    console.log("last", a);
    next();
});
/**
 * Begin Test
 */
AEE.emit("hello", [1], function (err) {
    if (err) {
        console.log(err);
    }
});
AEE.emit("hello", [2], function (err) {
    if (err) {
        console.log(err);
    }
});
AEE.emit("hello", [3], function (err) {
    if (err) {
        console.log(err);
    }
});
SEE.emit("test", [1]);
SEE.emit("test", [2]);
SEE.emit("test", [3]);
//# sourceMappingURL=events.js.map