"use strict";
require("langext");
var lrts_1 = require("../lrts");
var http_1 = require("../modules/http");
var server = http_1.Server.create({
    "host": "127.0.0.1",
    "port": 80
});
server.get("/", function (request, response, server, next) {
    response.setHeader("Content-Type", "text/html");
    response.write("<!doctype html>\n<html lang=\"zh_CN\">\n    <head>\n        <meta charset=\"utf-8\">\n        <title>Test</title>\n    </head>\n    <body>\n        <script src=\"static/modules/common.js\"></script>\n        <script src=\"static/modules/cache/index.js\"></script>\n        Hello world!\n    </body>\n</html>\n");
    next();
});
server.get("/user", function (request, response, server, next) {
    response.write("who are you?");
    next();
});
server.get("/user/{id:uint}", function (request, response, server, next) {
    if (request.query["action"]) {
        response.write("hello, you uid is " + request.params["id"] + ", do you wanna " + request.query["action"] + "?");
    }
    else {
        response.write("hello, you uid is " + request.params["id"]);
    }
    next();
});
server.on("/http/404", function (request, response, server, next) {
    response.statusCode = 404;
    response.statusMessage = "NOT FOUND";
    response.end("FILE NOT FOUND.");
    next();
});
lrts_1.cache.memory.create("httpStatic");
server.use(http_1.middlewares.QueryParser);
server.use(http_1.middlewares.StaticDelegate({
    "prefix": "/static/",
    "root": "./",
    "expires": 86400,
    "memoryStorage": {
        "table": lrts_1.cache.memory.get("httpStatic")
    }
}));
server.start(function (err) {
    if (err) {
        console.log("Error: Failed to listen to " + server.host + ":" + server.port + ".");
    }
    else {
        console.log("Server started with listening to " + server.host + ":" + server.port);
    }
});
//# sourceMappingURL=http-server.js.map