
/**
 * The template type of hash-map
 */
export interface HashMap<T> {

    [key: string]: T;

}

export interface StdAsyncCallback {

    (err?: Exception): void;
}

/**
 * A common empty callback function.
 */
export function EmptyCallback() {

}

export class Exception extends Error implements Error {

    public readonly name;

    public readonly message;

    public constructor(name: string, msg: string) {

        super(`${name}(${msg})`);

        this.name = name;

        this.message = msg;
    }
}
