/**
 * This file defines the built-in middleware for parsing query-string.
 * 
 * This is one of the few built-in middlewares.
 */

import { Server, ServerRequest, ServerResponse, Middleware } from "../Server";

import NodeQS = require("querystring");

import events = require("../../events");

let QueryParser: Middleware = function(request: ServerRequest, response: ServerResponse, next: events.AsyncEventChainCallback): void {

    if (request.queryString) {

        request.query = NodeQS.parse(request.queryString);

    } else {

        request.query = {};
    }

    next();
};

export = QueryParser;
