
import { logger, Exception } from "../lrts";

let log: logger.Logger = new logger.ConsoleLogger();

log.write("Test");

log.write("Test", "info");

log.timeFormatter = function(): string {

    return new Date().getSimpleDate();
};

log.write("Test", undefined, function(err?: Exception): void {

    console.log("Log written.");
});

logger.FileLogger.create("log-test.log", function(err: Exception, flog: logger.Logger): void {

    if (err) {

        log.write("Failed to open file log.", "error");

    } else {

        flog.write("Test1", "default", function(err?: Exception) {

            console.log("File log written.");
        });

        flog.write("Test2", "error", function(err?: Exception) {

            console.log("File log written.");
        });
    }

});
