import { cache } from "../lrts";

if (cache.memory.create("ff")) {

    let table: cache.IMemoryTable<number> = cache.memory.get<number>("ff");

    table.add("a", 3321);
    table.add("b", 1233);

    table.set("c", 123333);

    table.ttl("c", 1000);

    console.log("Number: ", table.length);

    console.log("get(['a', 'b']) =", table.get(["a", "b"]));
    console.log("get('c') =", table.get("c"));

    console.log(table.ttl("c"));
    setTimeout(function() {

        table.gc(function() {
            console.log("Gabarge collected.");
        });

        console.log("Number: ", table.length);

        console.log(table.get("c"));
        console.log(table.ttl("c"));

        console.log("Number: ", table.length);

        table.truncate();

        console.log("Number: ", table.length);

        table = undefined;

        cache.memory.drop("ff");

        console.log(cache.memory.get<number>("ff"));

    }, 1500);
}
